unit Cmp_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Gauges, StdCtrls, ExtCtrls;

type
  TCmpForm = class(TForm)
    ButtonOk: TButton;
    LabelInst: TLabel;
    LabelCopyProgress: TLabel;
    GroupBoxCmp: TGroupBox;
    GaugeCmp: TGauge;
    TimerCmp: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure TimerCmpTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FFirstInst: Boolean;
    FCopyStr: string;
    FCopyStrEnd: string;
  public
  end;

var
  CmpForm: TCmpForm;

implementation

uses Exit_Frm;

{$R *.DFM}

procedure TCmpForm.FormCreate(Sender: TObject);
begin
  FFirstInst := True;
end;

procedure TCmpForm.FormShow(Sender: TObject);
begin
  GaugeCmp.Progress := 0;
  LabelInst.Font.Color := clBlack;
  if FFirstInst then
    LabelInst.Caption := ' ...'
  else
    LabelInst.Caption := '  ...';
  if FFirstInst then
    FCopyStr := ': '
  else
    FCopyStr := ':  ';
  FCopyStrEnd := ' ';
  ButtonOk.Enabled := False;
  TimerCmp.Enabled := True;
end;

procedure TCmpForm.FormHide(Sender: TObject);
begin
  if ButtonOk.Enabled then
    FFirstInst := False;
  TimerCmp.Enabled := False;
end;

procedure TCmpForm.TimerCmpTimer(Sender: TObject);
begin
  with GaugeCmp, LabelCopyProgress do
    if Progress < MaxValue then
    begin
      Progress := Progress + 1;
      Caption := Format(FCopyStr + '%.1f' + FCopyStrEnd,
      [Progress / MaxValue]);
    end;
  if GaugeCmp.Progress >= GaugeCmp.MaxValue then
  begin
    MessageBeep(mb_IconExclamation);
    LabelInst.Font.Color := clRed;
    if FFirstInst then
      LabelInst.Caption := '  '
    else
      LabelInst.Caption := '    ';
    TimerCmp.Enabled := False;
    ButtonOk.Enabled := True;
  end;
end;

end.
