{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit Copy_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, MPlayer, ComCtrls;

const
  HardDiskMidiName = 'Inst_Vir.Da2';
  TimeLimitMilliSec = 60000;
  FileBlockSize = 1024;
  FileReadBlockNum: Integer = 7;
  SkipNum = 15;
  StartGoLimitDec = 73;
  BackGoLimitDec = 47;
  EndGoLimitDec = 98;
  SectNextNum = 20;
  MinDiskSect = 100000;
  MinDiskSectNum = 123;

type
  TCopyForm = class(TForm)
    ButtonCancel: TButton;
    GaugeN1: TGauge;
    GaugeN2: TGauge;
    GaugeN3: TGauge;
    GaugeSect: TGauge;
    GaugeFile: TGauge;
    LabelSectStr: TLabel;
    LabelSect: TLabel;
    LabelFileStr: TLabel;
    LabelFile: TLabel;
    MediaPlayerCopy: TMediaPlayer;
    LabelSizeStr: TLabel;
    LabelSize: TLabel;
    RichEditFile: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FMidiOpened: Boolean;
    FStopWork: Boolean;
    FNext: Boolean;
    FGoMode: (gmStart, gmBack, gmEnd);
    FFilesSize: Integer;
    FFilesSizeRead: Integer;
    FFileNum: Integer;
    FCurFilesSizeRead: Integer;
    FUsedDiskSect: Integer;
    FCurFile: File;
    FFileBf: array[1..FileBlockSize] of Byte;
    DestFilesList: TStringList;
    DestFilesSizeList: TList;
    procedure ShowBckMessage;
    procedure ShowNrmMessage;
    procedure ShowEndMessage;
  public
    procedure FixMidiPlay(var Done: Boolean);
    procedure FixGaugeN2(var Done: Boolean);
    procedure FixGaugeN3(var Done: Boolean);
    procedure FixGaugeFile(var Done: Boolean);
  end;

var
  CopyForm: TCopyForm;

implementation

uses Exit_Frm, Inst_Frm, Dsk3_Frm;

{$R *.DFM}

procedure TCopyForm.FormCreate(Sender: TObject);
begin
  FMidiOpened := False;
  DestFilesList := TStringList.Create;
  DestFilesSizeList := TList.Create;
end;

procedure TCopyForm.FormShow(Sender: TObject);
  var
    i_1, i_2, i_3: Integer;
    s_1, s_2: string;
    sr: TSearchRec;
begin
  MediaPlayerCopy.FileName :=
  ExtractFilePath(Application.ExeName) + HardDiskMidiName;
  MediaPlayerCopy.Open;
  FMidiOpened := True;
  DestFilesList.Clear;
  DestFilesSizeList.Clear;
  FFilesSize := 0;
  for i_1 := 0 to MainForm.DestDirsList.Count - 1 do
  begin
    s_1 := MainForm.DestDirsList[i_1];
    i_2 := FindFirst(MainForm.DestDirsList[i_1],
    faReadOnly + faHidden + faSysFile + faArchive, sr);
    s_1 := AddDirSlash(ExtractFilePath(s_1));
    while i_2 = 0 do
    begin
      s_2 := AnsiUpperCase(Trim(ExtractFileExt(sr.Name)));
      if (s_2 = '.COM') or (s_2 = '.EXE') or
      (s_2 = '.DLL') or (s_2 = '.DRV') then
      begin
        s_2 := AnsiUpperCase(Trim(s_1 + sr.Name));
        if not DestFilesList.Find(s_2, i_3) then
        begin
          DestFilesList.Add(s_2);
          DestFilesSizeList.Add(MakeCopy(sr.Size, SizeOf(Integer)));
          FFilesSize := FFilesSize + sr.Size;
        end;
      end;
      i_2 := FindNext(sr);
    end;
  end;
  FindClose(sr);
  FFilesSizeRead := 0;
  FFileNum := 0;
  FCurFilesSizeRead := -1;
  FNext := True;
  FGoMode := gmStart;
  FStopWork := False;
  FUsedDiskSect := DiskSize(DiskNameToNum(UsedDisk)) div 512;
  if FUsedDiskSect < MinDiskSect then
    FUsedDiskSect := MinDiskSect;
end;

procedure TCopyForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult <> mrOk then
    CanClose := ExitForm.DoQuit;
end;

procedure TCopyForm.FormHide(Sender: TObject);
begin
  FMidiOpened := False;
  MediaPlayerCopy.Close;
  if FCurFilesSizeRead <> -1 then
    CloseFile(FCurFile);
  FFileNum := -1;
end;

procedure TCopyForm.FormDestroy(Sender: TObject);
begin
  DestFilesList.Free;
  FreeList(DestFilesSizeList, SizeOf(Integer));
  DestFilesSizeList.Free;
end;

procedure TCopyForm.ShowBckMessage;
begin
  Application.MessageBox(
  '     .' + #13#10 +
  '       :' + #13#10 +
  #13#10 +
  '      [125b]' + #13#10 +
  #13#10 +
  '   EAX = 01234567; EBX = 89101112; ECX = 13141516; EDX = 17181920.....' + #13#10 +
  '----------------------------------------------------------------------' + #13#10 +
  '          Windows',
  'System halted error protection failure fatal',
  mb_Ok + mb_IconStop);
end;

procedure TCopyForm.ShowNrmMessage;
  var
    s: string;
begin
  if Screen.Width >= 800 then
    s := '.. : 01( )'
  else
    s := '.. -:01( )';
  Application.MessageBox(
  '     .' + #13#10 +
  '       :' + #13#10 +
  #13#10 +
  '       [113prim]' + #13#10 +
  #13#10 +
  '   EAX = 32332223; EBX = 33233333; ECX = 232333.2; EDX = -2333222.....' + #13#10 +
  '----------------------------------------------------------------------' + #13#10 +
  '           ',
  PChar(s), mb_Ok + mb_IconStop);
end;

procedure TCopyForm.ShowEndMessage;
begin
  if Dsk3Form.ShowModal <> mrOk then
  Application.MessageBox(
  '     #%$&%#&%$#-!!!' + #13#10 +
  '      VIRUS.DLL: " VIR_VxD.DRV     "  :' + #13#10 +
  #13#10 +
  '        [0]' + #13#10 +
  #13#10 +
  '   EAX = EBX = ECX = EDX = 00000000000000000000000000000000000000.....' + #13#10 +
  '----------------------------------------------------------------------' + #13#10 +
  '      :    ' + #13#10 +
  #13#10 +
  '    "OK"     DOS',
  'Computer Destroyed',
  mb_Ok + mb_IconStop);
end;

procedure TCopyForm.FixMidiPlay(var Done: Boolean);
begin
  if Visible then
  begin
    if (FMidiOpened) and (MediaPlayerCopy.Mode <> mpPlaying) then
      MediaPlayerCopy.Play;
    Done := False;
  end;
end;

procedure TCopyForm.FixGaugeN2(var Done: Boolean);
begin
  if (Visible) and (not FStopWork) and
  (FFileNum >= 0) and (FFileNum < DestFilesList.Count) then
    with GaugeN2 do
      if FNext then
        if Progress >= MaxValue then
          Progress := 0
        else
          Progress := Progress + 1
      else
        if Progress <= 0 then
          Progress := MaxValue
        else
          Progress := Progress - 1
end;

procedure TCopyForm.FixGaugeN3(var Done: Boolean);
begin
  if (Visible) and (not FStopWork) and
  (FFileNum >= 0) and (FFileNum < DestFilesList.Count) then
    with GaugeN3 do
      if FNext then
        if Progress >= MaxValue then
          Progress := 0
        else
          Progress := Progress + 1
      else
        if Progress <= 0 then
          Progress := MaxValue
        else
          Progress := Progress - 1
end;

procedure TCopyForm.FixGaugeFile(var Done: Boolean);
  var
    i_1, i_2, i_3, i_4, beg_file_ticks: Integer;
  procedure ShowGaugeN1Progress;
    var
      i: Integer;
  begin
    if FCurFilesSizeRead = -1 then
      i := 0
    else
      i := Round((FCurFilesSizeRead / Integer(DestFilesSizeList[FFileNum]^)) *
      GaugeN1.MaxValue);
    if FNext then
      GaugeN1.Progress := i
    else
      GaugeN1.Progress := GaugeN1.MaxValue - i;
  end;
  procedure ShowGaugeSectProgress;
    const
      LastFileNum: Integer = -1;
      CurSectNum: Integer = 0;
  begin
    if (Visible) and (FFileNum >= 0) and (FFileNum < DestFilesList.Count) then
    begin
      if (LastFileNum <> FFileNum) or (Random(SectNextNum) = 0) then
      begin
        CurSectNum := MinDiskSectNum + Random(FUsedDiskSect - MinDiskSectNum);
        LastFileNum := FFileNum;
      end
      else
        CurSectNum := CurSectNum + 1;
      LabelSect.Caption := Format('%.0n', [Int(CurSectNum)]);
      GaugeSect.Progress :=
      Round((FFilesSizeRead / FFilesSize) * GaugeSect.MaxValue);
    end;
  end;
begin
  if FStopWork then
    Exit;
  if Visible then
    Done := False;
  {---}
  if (Visible) and (FGoMode = gmStart) and (FFilesSizeRead > FFilesSize div
  100 * StartGoLimitDec) and (FCurFilesSizeRead = -1) then
  begin
    FStopWork := True;
    ShowBckMessage;
    FStopWork := False;
    LabelSectStr.Caption := ' :';
    LabelFileStr.Caption := ' :';
    FFileNum := FFileNum - 1;
    FNext := False;
    FGoMode := gmBack;
  end;
  {---}
  if (Visible) and (FGoMode = gmBack) and (FFilesSizeRead < FFilesSize div
  100 * BackGoLimitDec) and (FCurFilesSizeRead = -1) then
  begin
    FStopWork := True;
    ShowNrmMessage;
    FStopWork := False;
    LabelSectStr.Caption := ' :';
    LabelFileStr.Caption := ' :';
    FFileNum := FFileNum + 1;
    FNext := True;
    FGoMode := gmEnd;
  end;
  {---}
  if (Visible) and (FGoMode = gmEnd) and (FFilesSizeRead > FFilesSize div
  100 * EndGoLimitDec) and (FCurFilesSizeRead = -1) then
  begin
    FStopWork := True;
    GaugeN2.Progress := GaugeN2.MaxValue;
    GaugeN3.Progress := GaugeN3.MaxValue;
    ShowEndMessage;
    FFileNum := -1;
    ModalResult := mrOk;
  end;
  {---}
  if (Visible) and (FFileNum >= 0) and (FFileNum < DestFilesList.Count) then
  begin
    if FCurFilesSizeRead = -1 then
    begin
      AssignFile(FCurFile, DestFilesList[FFileNum]);
      LabelFile.Caption := DestFilesList[FFileNum];
      GaugeFile.Progress := (FFileNum + 1) * 100 div DestFilesList.Count;
      if FNext then
        RichEditFile.Lines.Add(DestFilesList[FFileNum])
      else
        RichEditFile.Lines.Delete(FFileNum);
      ShowGaugeN1Progress;
      FileMode := 0;
      try
        Reset(FCurFile, 1);
        FCurFilesSizeRead := 0;
      except
        on EInOutError do
        begin
          if FNext then
          begin
            FFilesSizeRead := FFilesSizeRead +
            Integer(DestFilesSizeList[FFileNum]^);
            RichEditFile.Lines[FFileNum] := RichEditFile.Lines[FFileNum] +
            ' -  /';
            FFileNum := FFileNum + 1;
          end
          else
            FFileNum := FFileNum - 1;
        end;
      end;
    end
    else
    begin     {@@@}
      i_4 := FCurFilesSizeRead;
      try
        beg_file_ticks := GetTickCount;
        for i_1 := 1 to FileReadBlockNum do
        begin
          if FCurFilesSizeRead + FileBlockSize <=
          Integer(DestFilesSizeList[FFileNum]^) then
            i_2 := FileBlockSize
          else
            i_2 := Integer(DestFilesSizeList[FFileNum]^) - FCurFilesSizeRead;
          BlockRead(FCurFile, FFileBf, i_2);
          FCurFilesSizeRead := FCurFilesSizeRead + i_2;
          if FCurFilesSizeRead >= Integer(DestFilesSizeList[FFileNum]^) then
            Break;
        end;
        if GetTickCount - beg_file_ticks < TimeLimitMilliSec div
        (DestFilesList.Count + 1) then
          FileReadBlockNum := FileReadBlockNum + 1
        else
          if FileReadBlockNum > 0 then
            FileReadBlockNum := FileReadBlockNum - 1;
      except
        on EInOutError do
          FCurFilesSizeRead := Integer(DestFilesSizeList[FFileNum]^);
      end;
      if FNext then
        FFilesSizeRead := FFilesSizeRead + (FCurFilesSizeRead - i_4)
      else
        FFilesSizeRead := FFilesSizeRead - (FCurFilesSizeRead - i_4);
      ShowGaugeN1Progress;
      if FCurFilesSizeRead >= Integer(DestFilesSizeList[FFileNum]^) then
      begin
        try
          CloseFile(FCurFile);
        except
          on EInOutError do;
        end;
        if FNext then
        begin
          if Random(SkipNum) = 0 then
            RichEditFile.Lines[FFileNum] := RichEditFile.Lines[FFileNum] +
            '  -  (    )'
          else
            RichEditFile.Lines[FFileNum] := RichEditFile.Lines[FFileNum] +
            ' -  ';
          FFileNum := FFileNum + 1;
        end
        else
          FFileNum := FFileNum - 1;
        FCurFilesSizeRead := -1;
      end;
    end;
    LabelSize.Caption := Format('%.0n', [Int(FFilesSizeRead)]);
  end;
  ShowGaugeSectProgress;
end;

end.
