{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit Detc_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MMSystem;

const
  HardDiskWavName = 'Inst_Vir.dat';

type
  TState = (dfNone, dfBegin, dfStarted, dfFoundDisp, dfFoundKeyb, dfFoundPrcs);

  TDetcForm = class(TForm)
    ImageWait: TImage;
    LabelOper: TLabel;
    TimerWait: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure TimerWaitTimer(Sender: TObject);
  private
    FState: TState;
    FHardDiskWavFullName: string;
    procedure SoundAndTimerOff;
  public
  end;

var
  DetcForm: TDetcForm;

implementation

uses Mont_frm, Inst_Frm, Keyb_Frm, Prcs_Frm, Exit_Frm;

{$R *.DFM}

procedure TDetcForm.FormShow(Sender: TObject);
begin
  FState := dfBegin;
  FHardDiskWavFullName :=
  ExtractFilePath(Application.ExeName) + HardDiskWavName;
  TimerWait.OnTimer(Sender);
end;

procedure TDetcForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult <> mrOk then
    CanClose := ExitForm.DoQuit;
end;

procedure TDetcForm.FormHide(Sender: TObject);
begin
  SoundAndTimerOff;
end;

procedure TDetcForm.TimerWaitTimer(Sender: TObject);
  var
    CurState: TState;
begin
  if FState = dfNone then
    Exit;
  SoundAndTimerOff;
  CurState := FState;
  FState := dfNone;
  case CurState of
    dfBegin: FState := dfStarted;
    dfStarted:
    begin
      MontForm.ShowModal;
      FState := dfFoundDisp;
    end;
    dfFoundDisp:
    begin
      KeybForm.ShowModal;
      FState := dfFoundKeyb;
    end;
    dfFoundKeyb:
    begin
      PrcsForm.ShowModal;
      FState := dfFoundPrcs;
      ModalResult := mrOk;
      Exit;
    end;
  end;
  Screen.Cursor := crHourGlass;
  sndPlaySound(PChar(FHardDiskWavFullName),
  snd_Async + snd_NoDefault + snd_Loop);
  TimerWait.Enabled := True;
end;

procedure TDetcForm.SoundAndTimerOff;
begin
  if (FState <> dfNone) and (FState <> dfBegin) and
  (FState <> dfFoundPrcs) then
  begin
    TimerWait.Enabled := False;
    sndPlaySound(Nil, snd_Sync);
    Screen.Cursor := crDefault;    
  end;
end;

end.
