{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit DOS_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MMSystem;

const
  HardDiskThunderName = 'Inst_Vir.Da3';
  HardDiskStrikngName = 'Inst_Vir.Da4';
  HardDiskExplosnName = 'Inst_Vir.Da5';
  HardDiskOpeningName = 'Inst_Vir.Da6';
  HardDiskDOSPifName = 'Inst_Vir.Da7';

type
  TSndType = (snNone, snThunder, snStrikng, snExplosn, snOpening);

type
  TDOSForm = class(TForm)
    PaintBoxGrave: TPaintBox;
    PanelCross: TPanel;
    PanelDOSTable: TPanel;
    ShapeCrossVert: TShape;
    ShapeCrossHorz: TShape;
    LabelDOSTableName: TLabel;
    LabelDOSTableYears: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure PaintBoxGravePaint(Sender: TObject);
  private
    FFlRedraw: Boolean;
    procedure PlaySnd(SndType: TSndType);
  public
    procedure FixPictures(var Done: Boolean);
  end;

var
  DOSForm: TDOSForm;

implementation

uses Inst_Frm, Exit_Frm;

{$R *.DFM}

procedure TDOSForm.FormCreate(Sender: TObject);
begin
  FFlRedraw := False;
end;

procedure TDOSForm.FormPaint(Sender: TObject);
  var
    b: Boolean;
begin
  FFlRedraw := True;
  FixPictures(b);
end;

procedure TDOSForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult <> mrOk then
    CanClose := ExitForm.DoQuit;
end;

procedure TDOSForm.FormHide(Sender: TObject);
begin
  PlaySnd(snNone);
end;

procedure TDOSForm.PaintBoxGravePaint(Sender: TObject);
  var
    b: Boolean;
begin
  FFlRedraw := True;
  FixPictures(b);
end;

procedure TDOSForm.PlaySnd(SndType: TSndType);
  const
    ThunderLoopFlag = snd_Loop;
    StrikngLoopFlag = 0;
    ExplosnLoopFlag = snd_Loop;
    OpeningLoopFlag = snd_Loop;
  var
    prg_path: string;
begin
  prg_path := ExtractFilePath(Application.ExeName);
  case SndType of
    snThunder:
      sndPlaySound(PChar(prg_path + HardDiskThunderName), snd_Async +
      snd_NoDefault + ThunderLoopFlag);
    snStrikng:
      sndPlaySound(PChar(prg_path + HardDiskStrikngName), snd_Async +
      snd_NoDefault + StrikngLoopFlag);
    snExplosn:
      sndPlaySound(PChar(prg_path + HardDiskExplosnName), snd_Async +
      snd_NoDefault + ExplosnLoopFlag);
    snOpening:
      sndPlaySound(PChar(prg_path + HardDiskOpeningName), snd_Async +
      snd_NoDefault + OpeningLoopFlag);
  else
    sndPlaySound(Nil, snd_Sync);
  end;
end;

procedure TDOSForm.FixPictures(var Done: Boolean);
  const
    PicState: (stFirst, stBegin, stThunder, stStrikng, stExplosn,
    stOpening, stGrowingStart, stGrowingFinish, stEnd) = stFirst;
    StartTime: Integer = 0;
    SvLeft: Integer = 0;
    SvWidth: Integer = 0;
    SvTop: Integer = 0;
    SvHeight: Integer = 0;
    SvPanelTop: Integer = 0;
    MaxDTop = 5;
    MaxDLeft = 3;
    CurCoverPos: Integer = 0;
    SvCoverUp: Integer = 0;
    SvCoverDn: Integer = 0;
    SvCoverUpWidth: Integer = 0;
    SvCoverDnWidth: Integer = 0;
    SvCoverDnLeft: Integer = 0;
    CurGravePos: Integer = -1;
    CurGraveLeft: Integer = 0;
    CurGraveWidth: Integer = 0;
    CurGraveTop: Integer = 0;
    CurGraveHeight: Integer = 0;
    SvGraveTop: Integer = 0;
    SvGraveHeight: Integer = 0;
    GraveGrowHeightInc = 50;
    FlPlayStopped: Boolean = False;
    WaitBegin = 3000;
    WaitThunderBeg = 1000;
    WaitThunder = 2627;
    WaitExplosn = 3000;
    WaitOpening = 1000;
    WaitGrowingStart = 3000;
    WaitGrowingFinish = 3000;
    WaitEnd = 1500;
  var
    cur_ticks: Integer;
  {---}
  procedure Redraw;
    const
      LastCoverPos: Integer = -1;
      LastGravePos: Integer = -1;
      LastGraveLeft: Integer = -1;
      LastGraveWidth: Integer = -1;
      LastGraveTop: Integer = -1;
      LastGraveHeight: Integer = -1;
    var
      fl_redraw: Boolean;
      points: array[1..4] of TPoint;
  begin
    fl_redraw := FFlRedraw;
    if (CurCoverPos <> -1) and ((FFlRedraw) or
    (LastCoverPos <> CurCoverPos)) then
    begin
      fl_redraw := False;
      LastCoverPos := CurCoverPos;
      {---}
      points[3].X := SvCoverDnLeft + SvCoverDnWidth - 1;
      points[3].Y := SvCoverDn;
      points[4].X := SvCoverDnLeft + (SvCoverDnWidth - SvCoverUpWidth) div 2 +
      SvCoverUpWidth - 1;
      points[4].Y := SvCoverUp;
      points[1].X := points[4].X -
      CurCoverPos * SvCoverUpWidth div SvCoverDnWidth;
      points[1].Y := points[4].Y;
      points[2].X := points[3].X - CurCoverPos;
      points[2].Y := points[3].Y;
      Canvas.Brush.Color := clBlack;
      Canvas.Polygon(points);
      {---}
      points[3].X := points[2].X - 1;
      points[4].X := points[1].X - 1;
      points[1].X := points[4].X - SvCoverUpWidth + 1;
      points[2].X := points[3].X - SvCoverDnWidth + 1;
      Canvas.Brush.Color := clGray;
      Canvas.Polygon(points);
    end;
    {---}
    if (CurGravePos <> -1) and ((FFlRedraw) or
    (LastGravePos <> CurGravePos) or (LastGraveLeft <> CurGraveLeft) or
    (LastGraveWidth <> CurGraveWidth) or (LastGraveTop <> CurGraveTop) or
    (LastGraveHeight <> CurGraveHeight)) then
    begin
      fl_redraw := False;
      LastGravePos := CurGravePos;
      LastGraveLeft := CurGraveLeft;
      LastGraveWidth := CurGraveWidth;
      LastGraveTop := CurGraveTop;
      LastGraveHeight := CurGraveHeight;
      {---}
      points[1].X := CurGraveLeft + CurGravePos;
      points[1].Y := CurGraveTop;
      points[2].X := CurGraveLeft;
      points[2].Y := CurGraveTop + (CurGraveHeight - 1);
      points[3].X := CurGraveLeft + (CurGraveWidth - 1);
      points[3].Y := points[2].Y;
      points[4].X := CurGraveLeft + (CurGraveWidth - 1) - CurGravePos;
      points[4].Y := points[1].Y;
      Canvas.Brush.Color := clBlack;
      Canvas.Polygon(points);
    end;
    FFlRedraw := fl_redraw;
  end;
  {---}
  procedure RunDOS(FlStart: Boolean);
    const
      SvCurDir: string = '';
      TempFileName = 'Temp$$$$';
      BatFileContain: string =
      '@Echo Type EXIT to exit, COPY to copy, RENAME to rename...' + #13#10 +
      '@Command';
    var
      size: Integer;
      p: Pointer;
      f, f_dest: file;
  begin
    if not FlStart then
    begin
      DeleteFile(ExtractFilePath(Application.ExeName) + TempFileName + '.PIF');
      DeleteFile(ExtractFilePath(Application.ExeName) + TempFileName + '.BAT');
      try
        ChDir(SvCurDir);
      except
        on EInOutError do;
      end;
      Exit;
    end;
    try
      AssignFile(f, ExtractFilePath(Application.ExeName) + HardDiskDOSPifName);
      AssignFile(f_dest, ExtractFilePath(Application.ExeName) + TempFileName +
      '.PIF');
      FileMode := 0;
      Reset(f, 1);
      FileMode := 1;
      try
        Rewrite(f_dest, 1);
        try
          size := FileSize(f);
          GetMem(p, size);
          try
            BlockRead(f, p^, size);
            BlockWrite(f_dest, p^, size);
          finally
            FreeMem(p, size);
          end;
        finally
          CloseFile(f_dest);
        end;
      finally
        CloseFile(f);
      end;
      AssignFile(f_dest, ExtractFilePath(Application.ExeName) + TempFileName +
      '.BAT');
      FileMode := 1;
      Rewrite(f_dest, 1);
      try
        BlockWrite(f_dest, BatFileContain[1], Length(BatFileContain));
      finally
        CloseFile(f_dest);
      end;
      try
        GetDir(0, SvCurDir);
      except
        on EInOutError do;
      end;
      ChDir(DelDirSlash(ExtractFilePath(Application.ExeName)));
      if WinExec(PChar(ExtractFilePath(Application.ExeName) + TempFileName +
      '.PIF'), sw_Show) <= 31 then
        raise EInOutError.Create('Internal run error');
    except
      on EInOutError do
        WinExec(PChar(GetEnv('COMSPEC')), sw_Show);
    end;
  end;
  {---}
begin
  if Visible then
  begin
    cur_ticks := GetTickCount;
    case PicState of
      stFirst:
      begin
        SvCoverUp := PaintBoxGrave.Top;
        SvCoverDn := PaintBoxGrave.Top + PaintBoxGrave.Height - 1;
        SvCoverUpWidth := PanelCross.Width;
        SvCoverDnWidth := PaintBoxGrave.Width;
        SvCoverDnLeft := PaintBoxGrave.Left;
        PicState := stBegin;
        StartTime := cur_ticks;
      end;
      stBegin:
        if cur_ticks - StartTime >= WaitBegin then
        begin
          PicState := stThunder;
          SvLeft := Left;
          SvWidth := Width;
          SvTop := Top;
          SvHeight := Height;
          PlaySnd(snThunder);
          StartTime := cur_ticks;
        end;
      stThunder:
        if cur_ticks - StartTime <= WaitThunder then
        begin
          Left := SvLeft + (Random(MaxDLeft * 2 + 1) - MaxDLeft);
          Top := SvTop + (Random(MaxDTop * 2 + 1) - MaxDTop);
        end
        else
        begin
          PicState := stStrikng;
          Top := SvTop;
          Left := SvLeft;
          SvPanelTop := PanelCross.Top;
          PlaySnd(snStrikng);
          StartTime := cur_ticks;
        end;
      stStrikng:
        if cur_ticks - StartTime <= WaitThunder then
          PanelCross.Top := SvPanelTop - (SvPanelTop + PanelCross.Height) *
          (cur_ticks - StartTime) div WaitThunderBeg
        else
        begin
          PicState := stExplosn;
          PlaySnd(snExplosn);
          StartTime := cur_ticks;
        end;
      stExplosn:
        if cur_ticks - StartTime <= WaitExplosn then
          CurCoverPos := SvCoverDnWidth * (cur_ticks - StartTime) div
          WaitExplosn
        else
        begin
          CurCoverPos := SvCoverDnWidth;
          CurGraveLeft := SvCoverDnLeft;
          CurGraveWidth := SvCoverDnWidth;
          CurGraveTop := SvCoverUp;
          CurGraveHeight := SvCoverDn - SvCoverUp + 1;
          PicState := stOpening;
          PlaySnd(snOpening);
          StartTime := cur_ticks;
        end;
      stOpening:
        if cur_ticks - StartTime <= WaitOpening then
        begin
          CurGravePos := ((SvCoverDnWidth - SvCoverUpWidth) div 2) *
          (WaitOpening - (cur_ticks - StartTime)) div WaitOpening;
          CurGraveHeight := (SvCoverDn - SvCoverUp + 1) +
          GraveGrowHeightInc * (cur_ticks - StartTime) div WaitOpening;
          CurGraveTop := SvCoverDn - (CurGraveHeight - 1);
        end
        else
        begin
          CurGravePos := 0;
          SvGraveTop := CurGraveTop;
          SvGraveHeight := CurGraveHeight;
          PicState := stGrowingStart;
          StartTime := cur_ticks;
        end;
      stGrowingStart:
        if cur_ticks - StartTime <= WaitGrowingStart then
        begin
          CurGraveLeft := SvCoverDnLeft - SvCoverDnLeft *
          (cur_ticks - StartTime) div WaitGrowingStart;
          CurGraveWidth := SvCoverDnWidth + (Width - SvCoverDnWidth) *
          (cur_ticks - StartTime) div WaitGrowingStart;
          CurGraveTop := SvGraveTop - SvGraveTop *
          (cur_ticks - StartTime) div WaitGrowingStart;
          CurGraveHeight := SvGraveHeight + (Height - SvGraveHeight) *
          (cur_ticks - StartTime) div WaitGrowingStart;
        end
        else
        begin
          CurCoverPos := -1;
          CurGravePos := -1;
          Color := clBlack;
          PicState := stGrowingFinish;
          StartTime := cur_ticks;
        end;
      stGrowingFinish:
        if cur_ticks - StartTime <= WaitGrowingFinish then
        begin
          Left := SvLeft - SvLeft *
          (cur_ticks - StartTime) div WaitGrowingFinish;
          Width := SvWidth + (Screen.Width - SvWidth) *
          (cur_ticks - StartTime) div WaitGrowingFinish;
          Top := SvTop - SvTop *
          (cur_ticks - StartTime) div WaitGrowingFinish;
          Height := SvHeight + (Screen.Height - SvHeight) *
          (cur_ticks - StartTime) div WaitGrowingFinish;
        end
        else
        begin
          Left := 0;
          Width := Screen.Width;
          Top := 0;
          Height := Screen.Height;
          FlPlayStopped := False;
          PicState := stEnd;
          StartTime := cur_ticks;
          RunDOS(True);
        end;
      stEnd:
        if cur_ticks - StartTime > WaitEnd then
        begin
          if not FlPlayStopped then
          begin
            FlPlayStopped := True;
            PlaySnd(snNone);
          end;
          if Application.Active then
          begin
            RunDOS(False);
            ModalResult := mrOk;
          end;
        end;
    end;
    Redraw;
    Done := False;
  end;
end;

end.
