{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit Inst_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

const
  MinDiskFree = 0;
  MinDiskNeed = 3141592;
  DiskNeedInc = 1;

var
  UsedDisk: string;
  SourDir: string;

type
  TDirStringList = class(TStringList)
    function Add(const S: string): Integer; override;
  end;

type
  TMainForm = class(TForm)
    TimerMain: TTimer;
    PanelInstall: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TimerMainTimer(Sender: TObject);
  private
    FTimerCounter: Integer;
    FFlStart: Boolean;
    procedure ApplicationMessage(var Msg: TMsg; var Handled: Boolean);
    procedure ApplicationIdle(Sender: TObject; var Done: Boolean);
  public
    DestDirsList: TDirStringList;
    function GetDiskFree: Integer;
    function GetDiskNeed: Integer;
    procedure FixPanelInstall(var Done: Boolean);
  end;

var
  MainForm: TMainForm;

function MakeCopy(const Bf; Size: Integer): Pointer;
procedure FreeList(List: TList; ItemSize: Integer);
function GetCurDir: string;
function GetWinDir: string;
function GetSySDir: string;
function ExtractFileDisk(const FileName: string): string;
function GetCurDisk: string;
function DiskNumToName(DiskNum: Byte): string;
function DiskNameToNum(const Disk: string): Byte;
function ExtractFileDiskDef(const FileName: string; DefDiskNum: Byte): string;
function AddDirSlash(const DirName: string): string;
function DelDirSlash(const DirName: string): string;
function DiskExists(DiskNum: Byte): Boolean;
function DirExists(const DirName: string): Boolean;
function DirNameMaskToMask(const DirNameMask: string): string;
function FilesMaskExists(const FilesMask: string): Boolean;
procedure AddList(const ListStr: string; const ListStrDiv: string;
StringList: TStringList);
function GetList(StringList: TStringList; const ListStrDiv: string): string;
function GetEnv(EnvPrmName: string): string;

implementation

uses
  PreR_Frm, Exit_Frm, Quit_Frm, SerN_Frm, SHlp_Frm, Detc_Frm, Wiz_Frm,
  MxWr_Frm, Cust_Frm, Copy_Frm, Dsk3_Frm, DOS_Frm, Info_Frm;

{$R *.DFM}

function MakeCopy(const Bf; Size: Integer): Pointer;
begin
  GetMem(Result, Size);
  Move(Bf, Result^, Size);
end;

procedure FreeList(List: TList; ItemSize: Integer);
  var
    i: Integer;
begin
  for i := 0 to List.Count - 1 do
    FreeMem(List[i], ItemSize);
end;

function GetCurDir: string;
begin
  Result := '';
  SetLength(Result, GetCurrentDirectory(0, PChar(Result)));
  GetCurrentDirectory(Length(Result), PChar(Result));
  Result := Trim(Result);
end;

function GetWinDir: string;
begin
  Result := '';
  SetLength(Result, GetWindowsDirectory(PChar(Result), 0));
  GetWindowsDirectory(PChar(Result), Length(Result));
  Result := Trim(Result);
end;

function GetSySDir: string;
begin
  Result := '';
  SetLength(Result, GetSystemDirectory(PChar(Result), 0));
  GetSystemDirectory(PChar(Result), Length(Result));
  Result := Trim(Result);
end;

{ : "C:"}
function ExtractFileDisk(const FileName: string): string;
begin
  Result := '';
  if Length(FileName) >= 2 then
    if FileName[2] = ':' then
      Result := Copy(FileName, 1, 2);
end;

function GetCurDisk: string;
begin
  Result := ExtractFileDisk(GetCurDir);
  if Length(Result) < 2 then
    Result := 'C:';
end;

{DefNum: 0 - , 1 - A:, 2 - B:  ..}
function DiskNumToName(DiskNum: Byte): string;
begin
  if DiskNum <= 0 then
    Result := GetCurDisk
  else
    Result := Chr(DiskNum + (Ord('A') - 1)) + ':';
end;

{   0}
function DiskNameToNum(const Disk: string): Byte;
  var
    s: string;
begin
  Result := 0;
  if Length(Disk) = 2 then
    if Disk[2] = ':' then
    begin
      s := AnsiUpperCase(Disk[1]);
      Result := Ord(s[1]) - (Ord('A') - 1);
    end;
end;

function ExtractFileDiskDef(const FileName: string; DefDiskNum: Byte): string;
begin
  Result := ExtractFileDisk(FileName);
  if Length(Result) < 2 then
    Result := DiskNumToName(DefDiskNum);
end;

function AddDirSlash(const DirName: string): string;
begin
  Result := DirName;
  if DirName <> '' then
    if DirName[Length(DirName)] <> '\' then
      Result := DirName + '\';
end;

function DelDirSlash(const DirName: string): string;
begin
  Result := DirName;
  if (DirName <> '') and (DirName <> '\') and
  ((Length(DirName) <> 3) or (Copy(DirName, 2, 2) <> ':\')) then
    if DirName[Length(DirName)] = '\' then
      Result := Copy(DirName, 1, Length(DirName) - 1);
end;

function DiskExists(DiskNum: Byte): Boolean;
begin
  Result := (DiskSize(DiskNum) <> -1);
end;

function DirExists(const DirName: string): Boolean;
  var
    i_1, i_2: Byte;
    s: string[1];
    sr: TSearchRec;
begin
  Result := False;
  i_1 := DiskNameToNum(ExtractFileDisk(DirName));
  if i_1 = 0 then
    i_2 := 1
  else
    i_2 := 3;
  if (Length(DirName) <= i_2) then
  begin
    s := Copy(DirName, i_2, 1);
    if (s = '') or (s = '\') then
    begin
      Result := DiskExists(i_1);
      Exit;
    end;
  end;
  if (Pos('*', DirName) <> 0) or (Pos('?', DirName) <> 0) then
    Exit;
  if FindFirst(DelDirSlash(DirName), faAnyFile, sr) = 0 then
    Result := (sr.Attr and faDirectory <> 0);
  FindClose(sr);
end;

{    ,   -   
 ,   - DirNameMask}
function DirNameMaskToMask(const DirNameMask: string): string;
begin
  if DirExists(DirNameMask) then
    Result := AddDirSlash(DirNameMask) + '*.*'
  else
    Result := DirNameMask;
end;

function FilesMaskExists(const FilesMask: string): Boolean;
  var
    sr: TSearchRec;
begin
  Result := (FindFirst(FilesMask,
  faReadOnly + faHidden + faSysFile + faArchive, sr) = 0);
  FindClose(sr);
end;

procedure AddList(const ListStr: string; const ListStrDiv: string;
StringList: TStringList);
  var
    i: Integer;
    s: string;
begin
  s := ListStr;
  repeat
    if ListStrDiv = '' then
      i := 0
    else
      i := Pos(ListStrDiv, s);
    if i = 0 then
    begin
      if s <> '' then
        StringList.Add(Trim(s));
    end
    else
    begin
      StringList.Add(Trim(Copy(s, 1, i - 1)));
      Delete(s, 1, i + Length(ListStrDiv) - 1);
    end;
  until i = 0;
end;

function GetList(StringList: TStringList; const ListStrDiv: string): string;
  var
    i: Integer;
begin
  Result := '';
  with StringList do
  begin
    Sort;
    if Count <= 0 then
      Exit;
    Result := Strings[0];
    for i := 1 to Count - 1 do
      Result := Result + ListStrDiv + Strings[i];
  end;
end;

function GetEnv(EnvPrmName: string): string;
  var
    PEnvBf: PChar;
    EnvBfSize: Integer;
begin
  Result := '';
  EnvBfSize := GetEnvironmentVariable(PChar(EnvPrmName), PChar(Result), 0);
  if EnvBfSize > 0 then
  begin
    GetMem(PEnvBf, EnvBfSize);
    GetEnvironmentVariable(PChar(EnvPrmName), PEnvBf, EnvBfSize);
    Result := PEnvBf;
    FreeMem(PEnvBf, EnvBfSize);
  end;
end;

function TDirStringList.Add(const S: string): Integer;
  var
    i: Integer;
    upper_str: string;
begin
  upper_str := AnsiUpperCase(Trim(DirNameMaskToMask(S)));
  if (FilesMaskExists(upper_str)) and (not Find(upper_str, i)) then
    inherited Add(upper_str);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DestDirsList := TDirStringList.Create;
  UsedDisk := ExtractFileDiskDef(GetWinDir, 0);
  SourDir :=
  AnsiUpperCase(Trim(DelDirSlash(ExtractFilePath(Application.ExeName))));
  if not DirExists(SourDir) then
    SourDir := '';
  AddList(UsedDisk + '; ' + GetWinDir + '; ' + GetSysDir, ';', DestDirsList);
  Application.OnIdle := ApplicationIdle;
  Application.OnMessage := ApplicationMessage;
  FFlStart := True;
  Left := 0;
  Top := 0;
  ClientWidth := Screen.Width;
  ClientHeight := Screen.Height;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Randomize;
  FTimerCounter := 0;
  TimerMain.Enabled := True;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if FFlStart then
  begin
    FFlStart := False;
    if PrergstForm.ShowModal = mrOk then
      if SerNoForm.ShowModal = mrOk then
        if DetcForm.ShowModal = mrOk then
          if WizForm.ShowModal = mrOk then
            if CustForm.ShowModal = mrOk then
              if CopyForm.ShowModal = mrOk then
                if DOSForm.ShowModal = mrOk then
                  InfoForm.ShowModal;
    ExitForm.DoQuit := True;
  end;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Repaint;
end;

procedure TMainForm.FormPaint(Sender: TObject);
  var
    i: Integer;
    rect: TRect;
begin
  with Canvas, ClipRect do
    for i := Top to Bottom - 1 do
    begin
      Brush.Color := (i * 255) div (ClientHeight - 1);
      rect.Left := Left;
      rect.Top := i;
      rect.Right := Right;
      rect.Bottom := i + 1;
      FillRect(rect);
    end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := ExitForm.DoQuit;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DestDirsList.Free;
end;

procedure TMainForm.TimerMainTimer(Sender: TObject);
begin
  FTimerCounter := FTimerCounter + 1;
end;

procedure TMainForm.ApplicationMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if Msg.Message = wm_KeyDown then
    if Msg.WParam = vk_Cancel then
    begin
      Handled := True;
      ExitForm.DoQuit := True;
    end;
end;

procedure TMainForm.ApplicationIdle(Sender: TObject; var Done: Boolean);
  type
    TIdleProcess = procedure(var Done: Boolean) of object;
  const
    FixPanelInstallNextRunTime: Integer = 0;
    FixPanelCaptionNextRunTime: Integer = 0;
    FixPanelColorNextRunTime: Integer = 0;
    FixImageConfirmNextRunTime: Integer = 0;
    FixImageErrorNextRunTime: Integer = 0;
    FixSHlpFormColorNextRunTime: Integer = 0;
    FixImageWizNextRunTime: Integer = 0;
    FixNoDiskSpaceNextRunTime: Integer = 0;
    FixTimeNextRunTime: Integer = 0;
    FixMidiPlayNextRunTime: Integer = 0;
    FixGaugeN2NextRunTime: Integer = 0;
    FixGaugeN3NextRunTime: Integer = 0;
    FixGaugeFileNextRunTime: Integer = 0;
    FixPicturesNextRunTime: Integer = 0;
  procedure RunIdleProcess(const IdleProcess: TIdleProcess;
  RunIntervalMlSec: Integer; var NextRunTimeMlSec: Integer; var Done: Boolean);
    var
      cur_ticks: Integer;
      sup_done: Boolean;
  begin
    cur_ticks := GetTickCount;
    if cur_ticks < NextRunTimeMlSec then
      Exit;
    sup_done := True;
    IdleProcess(sup_done);
    if sup_done then
    begin
      NextRunTimeMlSec := NextRunTimeMlSec + RunIntervalMlSec;
      if NextRunTimeMlSec < cur_ticks then
        NextRunTimeMlSec := cur_ticks;
    end
    else
      Done := False;
  end;
begin
  RunIdleProcess(FixPanelInstall, 700, FixPanelInstallNextRunTime, Done);
  RunIdleProcess(PrergstForm.FixPanelReclamCaption, 200,
  FixPanelCaptionNextRunTime, Done);
  RunIdleProcess(PrergstForm.FixPanelReclamColor, 100,
  FixPanelColorNextRunTime, Done);
  RunIdleProcess(ExitForm.FixImageConfirm, 100,
  FixImageConfirmNextRunTime, Done);
  RunIdleProcess(QuitForm.FixImageError, 100,
  FixImageErrorNextRunTime, Done);
  RunIdleProcess(SHlpForm.FixSHlpFormColor, 500,
  FixSHlpFormColorNextRunTime, Done);
  RunIdleProcess(WizForm.FixImageWiz, 500, FixImageWizNextRunTime, Done);
  RunIdleProcess(MxWrForm.FixNoDiskSpace, 700,
  FixNoDiskSpaceNextRunTime, Done);
  RunIdleProcess(CustForm.FixTime, 0, FixTimeNextRunTime, Done);
  RunIdleProcess(CopyForm.FixMidiPlay, 50, FixMidiPlayNextRunTime, Done);
  RunIdleProcess(CopyForm.FixGaugeN2, 50, FixGaugeN2NextRunTime, Done);
  RunIdleProcess(CopyForm.FixGaugeN3, 50, FixGaugeN3NextRunTime, Done);
  RunIdleProcess(CopyForm.FixGaugeFile, 0, FixGaugeFileNextRunTime, Done);
  RunIdleProcess(DOSForm.FixPictures, 0, FixPicturesNextRunTime, Done);
end;

function TMainForm.GetDiskFree: Integer;
begin
  Result := DiskFree(DiskNameToNum(UsedDisk));
  if Result < MinDiskFree then
    Result := MinDiskFree;
end;

function TMainForm.GetDiskNeed: Integer;
begin
  Result := GetDiskFree + DiskNeedInc;
  if Result < MinDiskNeed then
    Result := MinDiskNeed;
end;

procedure TMainForm.FixPanelInstall(var Done: Boolean);
begin
  if Visible then
    PanelInstall.Visible := not PanelInstall.Visible;
end;

end.

