{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit SHlp_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TSHlpForm = class(TForm)
    ButtonOk: TButton;
    RichEditHlp: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FStartFormColor: TColor;
  public
    property StartFormColor: TColor read FStartFormColor;
    procedure FixSHlpFormColor(var Done: Boolean);
  end;

var
  SHlpForm: TSHlpForm;

implementation

{$R *.DFM}

procedure TSHlpForm.FormCreate(Sender: TObject);
begin
  FStartFormColor := ColorToRGB(Color);
end;

procedure TSHlpForm.FormShow(Sender: TObject);
begin
  Color := FStartFormColor;
end;

procedure TSHlpForm.FixSHlpFormColor(var Done: Boolean);
  const
    MaxDeltaRed = 2;
    MaxDeltaGreen = 2;
    MaxDeltaBlue = 2;
    MaxChangeRed = 15;
    MaxChangeGreen = 15;
    MaxChangeBlue = 15;
    FlIncRed: Boolean = True;
    FlIncGreen: Boolean = True;
    FlIncBlue: Boolean = True;
  var
    new_red, new_green, new_blue: Integer;
  function GetRed(Color: TColor): Integer;
  begin
    Result := Color and $0000FF;
  end;
  function GetGreen(Color: TColor): Integer;
  begin
    Result := (Color and $00FF00) div $100;
  end;
  function GetBlue(Color: TColor): Integer;
  begin
    Result := (Color and $FF0000) div $10000;
  end;
  function GetNewCol(StartCol, OldCol,
  MaxDelta, MaxChange: Integer; var FlInc: Boolean): Integer;
    var
      min_col, max_col: Integer;
  begin
    min_col := StartCol - MaxChange;
    if min_col < 0 then
      min_col := 0;
    max_col := StartCol + MaxChange;
    if max_col > $FF then
      max_col := $FF;
    if FlInc then
      Result := OldCol + Random(MaxDelta)
    else
      Result := OldCol - Random(MaxDelta);
    if Result > max_col then
    begin
      Result := max_col;
      FlInc := False;
    end;
    if Result < min_col then
    begin
      Result := min_col;
      FlInc := True;
    end;
  end;
begin
  if Visible then
    Color := RGB(GetNewCol(GetRed(StartFormColor), GetRed(Color),
    MaxDeltaRed, MaxChangeRed, FlIncRed),
    GetNewCol(GetGreen(StartFormColor), GetGreen(Color),
    MaxDeltaGreen, MaxChangeGreen, FlIncGreen),
    GetNewCol(GetBlue(StartFormColor), GetBlue(Color),
    MaxDeltaBlue, MaxChangeBlue, FlIncBlue));
end;

end.
