{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

unit Wiz_Frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TWizForm = class(TForm)
    ButtonBack: TButton;
    ButtonNext: TButton;
    ButtonCancel: TButton;
    ImageWiz: TImage;
    ImageSkel: TImage;
    ImageWizMax: TImage;
    ImageWizPort: TImage;
    ImageWizMin: TImage;
    ImageWizCust: TImage;
    RadioButtonMax: TRadioButton;
    RadioButtonPort: TRadioButton;
    RadioButtonMin: TRadioButton;
    RadioButtonCust: TRadioButton;
    LabelSetup: TLabel;
    LabelSetupInfo: TLabel;
    LabelMax: TLabel;
    LabelPort: TLabel;
    LabelMin: TLabel;
    LabelCust: TLabel;
    BevelWiz: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
  private
    SourBitmap, BkgrBitmap, ResltBitmap: TBitmap;
    BitmapDX, BitmapDY: Integer;
  public
    procedure FixImageWiz(var Done: Boolean);
  end;

var
  WizForm: TWizForm;

implementation

uses Exit_Frm, Max_Frm, MxWr_Frm, Port_Frm, PrNw_Frm, Cmp_Frm;

{$R *.DFM}

procedure TWizForm.FormCreate(Sender: TObject);
  var
    x, y: Integer;
    rect_1, rect_2: TRect;
begin
  SourBitmap := TBitmap.Create;
  SourBitmap.Width := ImageSkel.Picture.Bitmap.Width;
  SourBitmap.Height := ImageSkel.Picture.Bitmap.Height;
  BkgrBitmap := TBitmap.Create;
  BkgrBitmap.Width := ImageSkel.Picture.Bitmap.Width;
  BkgrBitmap.Height := ImageSkel.Picture.Bitmap.Height;
  ResltBitmap := TBitmap.Create;
  ResltBitmap.Palette := ImageWiz.Picture.Bitmap.Palette;
  ResltBitmap.Width := ImageSkel.Picture.Bitmap.Width;
  ResltBitmap.Height := ImageSkel.Picture.Bitmap.Height;
  BitmapDX := ImageSkel.Left - ImageWiz.Left;
  BitmapDY := ImageSkel.Top - ImageWiz.Top;
  SourBitmap.Canvas.Draw(0, 0, ImageSkel.Picture.Bitmap);
  rect_1.Left := 0;
  rect_1.Top := 0;
  rect_1.Right := BkgrBitmap.Width;
  rect_1.Bottom := BkgrBitmap.Height;
  rect_2.Left := BitmapDX;
  rect_2.Top := BitmapDY;
  rect_2.Right := BitmapDX + BkgrBitmap.Width;
  rect_2.Bottom := BitmapDY + BkgrBitmap.Height;
  BkgrBitmap.Canvas.CopyRect(rect_1, ImageWiz.Picture.Bitmap.Canvas, rect_2);
end;

procedure TWizForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult <> mrOk then
    CanClose := ExitForm.DoQuit;
end;

procedure TWizForm.FormDestroy(Sender: TObject);
begin
  SourBitmap.Free;
  BkgrBitmap.Free;
  ResltBitmap.Palette := 0;
  ResltBitmap.Free;
end;

procedure TWizForm.ButtonNextClick(Sender: TObject);
  const
    FlMaxFirst: Boolean = True;
begin
  if RadioButtonMax.Checked then
    if FlMaxFirst then
    begin
      MaxForm.ShowModal;
      FlMaxFirst := False;
    end
    else
      MxWrForm.ShowModal;
  if RadioButtonPort.Checked then
    if PortForm.ShowModal = mrOk then
      while PrNwForm.ShowModal = mrOk do;
  if RadioButtonMin.Checked then
    CmpForm.ShowModal;
  if RadioButtonCust.Checked then
    ModalResult := mrOk;
end;

procedure TWizForm.FixImageWiz(var Done: Boolean);
  const
    SimlNum = 50;
    CurSiml: Byte = SimlNum;
    FlIncSiml: Boolean = False;
    CurY: Integer = 0;
  var
    x, y: Integer;
  function ChangeCol(Sour, Mask: TColor): TColor;
    type
      TColors = record
        RedPart, GreenPart, BluePart, Reserved: Byte;
      end;
    procedure ChangeColPart(var Sour: Byte; Mask: Integer);
    begin
      Sour := Sour + (Mask - Sour) * CurSiml div SimlNum;
    end;
  begin
    ChangeColPart(TColors(Sour).RedPart, TColors(Mask).RedPart);
    ChangeColPart(TColors(Sour).GreenPart, TColors(Mask).GreenPart);
    ChangeColPart(TColors(Sour).BluePart, TColors(Mask).BluePart);
    Result := $02000000 + Sour;
  end;
begin
  if Visible then
  begin
    if CurY <= 0 then
    begin
      if ((FlIncSiml) and (CurSiml >= SimlNum)) or
      ((not FlIncSiml) and (CurSiml <= 0)) then
        FlIncSiml := not FlIncSiml;
      if FlIncSiml then
        CurSiml := CurSiml + 1
      else
        CurSiml := CurSiml - 1;
    end;
    for x := 0 to ImageSkel.Picture.Bitmap.Width - 1 do
    begin
      ResltBitmap.Canvas.Pixels[x, CurY] :=
      ChangeCol(SourBitmap.Canvas.Pixels[x, CurY],
      BkgrBitmap.Canvas.Pixels[x, CurY]);
    end;
    CurY := CurY + 1;
    if CurY >= ImageSkel.Picture.Bitmap.Height then
    begin
      ImageWiz.Picture.Bitmap.Canvas.Draw(BitmapDX, BitmapDY, ResltBitmap);
      CurY := 0;
    end
    else
      Done := False;
  end;
end;

end.

